﻿using System;

namespace TryCatchFinally {
	internal class Program {

		static void f(string text) {
			Console.WriteLine($"f(\"{text}\") called:");
			try {
				int value = int.Parse(text);
				Console.WriteLine($"  f: {text} times 2 = {value * 2}");
			} catch (FormatException ex) {
				Console.WriteLine($"  f: in catch, input is in wrong format\n     ({ex.GetType()}: {ex.Message})");
			} catch (OverflowException ex) {
				Console.WriteLine($"  f: in catch, input is out of range\n     ({ex.GetType()}: {ex.Message})");
			} finally {
				Console.WriteLine($"  f: in finally");
			}
		}

		static void Main(string[] args) {
			f("123");
			Console.WriteLine();
			f("ABC");
			Console.WriteLine();
			f("4200000000");
			Console.WriteLine();
			// Warning: Cannot convert null literal to non-nullable reference type.
			f(null);
		}
	}
}