﻿namespace ExceptionFiltersViaWhen {
	class Program {

		static bool MyTrueFilter(string calledFrom) {
			Console.WriteLine($"{nameof(MyTrueFilter)}(calledFrom='{calledFrom}')");
			return true;
		}

		static bool MyFalseFilter(string calledFrom) {
			Console.WriteLine($"{nameof(MyFalseFilter)}(calledFrom='{calledFrom}')");
			return false;
		}

		static bool MyHarryPottersFalseFilter(string calledFrom) {
			Console.WriteLine($"{nameof(MyHarryPottersFalseFilter)}(calledFrom='{calledFrom}')");
			return false;
		}

		static void f(int x) {
			try {
				Console.WriteLine($"{nameof(f)}(): entered try ...");
				g(x);
				Console.WriteLine($"{nameof(f)}(): leaving try ...");
			} catch (IndexOutOfRangeException) when (MyHarryPottersFalseFilter(nameof(f))) {
				Console.WriteLine($"{nameof(f)}(): 0st catch IndexOutOfRangeException ...");
			} catch (ArgumentException) when (MyTrueFilter(nameof(f))) {
				Console.WriteLine($"{nameof(f)}(): 1st catch ArgumentException ...");
			} catch (ArgumentException) when (MyFalseFilter(nameof(f))) {
				Console.WriteLine($"{nameof(f)}(): 2nd catch ArgumentException ...");
			} finally {
				Console.WriteLine($"{nameof(f)}(): in finally ...");
			}
		}

		static void g(int x) {
			try {
				Console.WriteLine($"{nameof(g)}(): entered try ...");
				if (x == 1) {
					throw new ArgumentException();
				} else if (x == 2) {
					throw new NotImplementedException();
				} else if (x == 3) {
					throw new IndexOutOfRangeException();
				} else if (x == 4) {
					g(x);
				}
				Console.WriteLine($"{nameof(g)}(): leaving try ...");
			} catch (ArgumentException) when (MyFalseFilter(nameof(g))) {
				Console.WriteLine($"{nameof(g)}(): catch ArgumentException ...");
			} finally {
				Console.WriteLine($"{nameof(g)}(): in finally ...");
			}
		}

		static void h(object sender, UnhandledExceptionEventArgs args) {
			Console.WriteLine($"*** {nameof(h)}: we are in our unhandled exception handler:");
			Console.WriteLine($"*** {nameof(h)}: .ExceptionObject: {args.ExceptionObject}");
			Console.WriteLine($"*** {nameof(h)}: .IsTerminating: {args.IsTerminating}");
		}

		static void Main(string[] args) {
			Console.Write("Register unhandled exception handler (Y/N)? ");
			if (Console.ReadLine().ToUpper() == "Y") {
				AppDomain.CurrentDomain.UnhandledException += h;
			}

			// Dark magic that starts second thread ... more in summer semester NPRG038
			// Try uncommenting ...
			// (new System.Threading.Thread(() => { while (true) { System.Threading.Thread.Sleep(250); Console.WriteLine("Second thread here ..."); /*/ throw new ArgumentException(); /**/ } })).Start();

			Console.Write("Enter value (0=no error, 1=ArgumentException, 2=NotImplementedException, 3=IndexOutOfRangeException, 4=unbound recursion): ");
			int value = int.Parse(Console.ReadLine());

			f(value);
		}
	}
}
