﻿namespace ExceptionChainPausingEx {
	class Program {
		static void Main(string[] args) {
			try {
				try {
					try {
						throw new ArgumentException();

					} finally { // ArgumentException propagation is "paused"
						Console.WriteLine("--- 1st finally ---");
					}   // Unpausing of ArgumentException -> gets propagated further

				} finally { // ArgumentException propagation is "paused" again
					Console.WriteLine("--- 2nd finally ---");
					try {
						throw new IndexOutOfRangeException();   // New exception is thrown inside finally - does NOT replace the paused ArgumentException yet!
																// Now: we still have "paused" ArgumentException + propagating IndexOutOfRangeException

					} catch {   // IndexOutOfRangeException propagation is "paused" - now we have 2 paused exceptions: the "older" ArgumentException and "newer" IndexOutOfRangeException
						Console.WriteLine("--- '3rd' catch ---");
					
					}   // IndexOutOfRangeException was handled -> it's propagation is cancelled -> now we have only 1 paused exception: the "older" ArgumentException

				}   // Unpausing of ArgumentException -> gets propagated further

			} catch (Exception e) { // ArgumentException propagation is "paused" again
				Console.WriteLine($"*** in catch (Exception) caught {e.GetType()} ***");
			}   // ArgumentException was handled -> it's propagation is cancelled
		}
	}
}
