﻿namespace ExceptionChainReplacingEx {
	class Program {
		static void Main(string[] args) {
			try {
				try {
					try {
						throw new ArgumentException();

					} finally { // ArgumentException propagation is "paused"
						Console.WriteLine("--- 1st finally ---");
					}   // Unpausing of ArgumentException -> gets propagated further

				} finally { // ArgumentException propagation is "paused"
					Console.WriteLine("--- 2nd finally ---");
					try {
						throw new IndexOutOfRangeException();   // New exception is thrown inside finally - does NOT replace the paused ArgumentException yet!
																// Now: we still have "paused" ArgumentException + propagating IndexOutOfRangeException

					} finally { // IndexOutOfRangeException propagation is "paused" - now we have 2 paused exceptions: the "older" ArgumentException and "newer" IndexOutOfRangeException
						Console.WriteLine("--- 3rd finally ---");

						throw new FormatException();    // Throwing new exception
														// Now we have 2 "paused" exceptions: "older" ArgumentException and "newer" IndexOutOfRangeException + propagating FormatException
					}   // The FormatException is NOT handled and propagates out of this finally block -> it replaces the IndexOutOfRangeException exception that was "paused" by this finally block
						// Now: we still have "paused" ArgumentException + propagating FormatException

				}   // The FormatException is NOT handled and propagates out of this finally block -> it replaces the ArgumentException exception that was "paused" by this finally block 

			} catch (Exception e) { // FormatException propagation is "paused"
				Console.WriteLine($"*** in catch (Exception) caught {e.GetType()} ***");
			}   // FormatException was handled -> it's propagation is cancelled
		}
	}
}
